"""
Copyright (c) 2013 Andras Retzler

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
"""

import sys

def main(filename):
	f=open(filename,"r")
	lines=f.readlines()
	f.close()
	
	#is it already converted?
	for l in lines:
		if l.count("(added by grcconvert)"):
			print "[grcconvert:error] File has already been converted."
			return 

	# we find out where we should insert our line
	insert_here=0
	for i, l in enumerate(lines):
		if l.count("# Blocks"):
			insert_here=i
			break
	insert_here-=1
	if insert_here<=0:
		print "[grcconvert:error] Not a GNUradio-companion generated top_level.py file."
		return

	text="\t\t##################################################\n\t\t# Message queues (added by grcconvert)\n\t\t##################################################\n\t\tself.msgq_out = gr_message_sink_0_msgq_out = gr.msg_queue(2)\n\n"
	lines=lines[:insert_here]+[text]+lines[insert_here:]

	#we comment out the last connect()
	found=0
	for i, l in enumerate(lines):
		if l.count("(self.gr_message_sink_0, msg)"):
			lines[i]=l[:2]+"#"+l[2:]
			found=1
			break
	if not found:
		print "[grcconvert:error] did not find line to comment"
		return

	f=open(filename,"w")
	f.writelines(lines)
	f.close()
	print "[grcconvert:info] converted:", filename
		
if __name__=="__main__":
	print "[grcconvert:info] msgq code inserter for GNUradio-companion generated top_level.py files"
	filename=sys.argv[1] if len(sys.argv)>1 else "top_block.py"
	main(filename)

