#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Top Block
# Generated: Sun Aug 25 23:59:43 2013
##################################################

from gnuradio import blks2
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.gr import firdes
from grc_gnuradio import wxgui as grc_wxgui
from optparse import OptionParser
import osmosdr
import wx

class top_block(grc_wxgui.top_block_gui):

	def __init__(self):
		grc_wxgui.top_block_gui.__init__(self, title="Top Block")
		_icon_path = "/usr/share/icons/hicolor/32x32/apps/gnuradio-grc.png"
		self.SetIcon(wx.Icon(_icon_path, wx.BITMAP_TYPE_ANY))

		##################################################
		# Variables
		##################################################
		self.samp_rate = samp_rate = 2048000
		self.fft_size = fft_size = 4096

		##################################################
		# Message queues (added by grcconvert)
		##################################################
		self.msgq_out = gr_message_sink_0_msgq_out = gr.msg_queue(2)

		##################################################
		# Blocks
		##################################################
		self.rtlsdr_source_c_0 = osmosdr.source_c( args="nchan=" + str(1) + " " + "rtl=0" )
		self.rtlsdr_source_c_0.set_sample_rate(samp_rate)
		self.rtlsdr_source_c_0.set_center_freq(145000000, 0)
		self.rtlsdr_source_c_0.set_freq_corr(0, 0)
		self.rtlsdr_source_c_0.set_gain_mode(1, 0)
		self.rtlsdr_source_c_0.set_gain(10, 0)
		self.rtlsdr_source_c_0.set_if_gain(24, 0)
			
		self.gr_message_sink_0 = gr.message_sink(gr.sizeof_float*fft_size, gr_message_sink_0_msgq_out, False)
		self.blks2_logpwrfft_x_0 = blks2.logpwrfft_c(
			sample_rate=samp_rate,
			fft_size=fft_size,
			ref_scale=2,
			frame_rate=1,
			avg_alpha=1.0,
			average=False,
		)

		##################################################
		# Connections
		##################################################
		#self.connect((self.gr_message_sink_0, msg), (self, 0))
		self.connect((self.rtlsdr_source_c_0, 0), (self.blks2_logpwrfft_x_0, 0))
		self.connect((self.blks2_logpwrfft_x_0, 0), (self.gr_message_sink_0, 0))


	def get_samp_rate(self):
		return self.samp_rate

	def set_samp_rate(self, samp_rate):
		self.samp_rate = samp_rate
		self.rtlsdr_source_c_0.set_sample_rate(self.samp_rate)
		self.blks2_logpwrfft_x_0.set_sample_rate(self.samp_rate)

	def get_fft_size(self):
		return self.fft_size

	def set_fft_size(self, fft_size):
		self.fft_size = fft_size

if __name__ == '__main__':
	parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
	(options, args) = parser.parse_args()
	tb = top_block()
	tb.Run(True)

